#ifndef SUDOKU_TRANSPOSE_HPP
#define SUDOKU_TRANSPOSE_HPP

#include <cmath>

namespace sudoku {

template <class Rand>
void transpose_square(Rand first, Rand last)
{
	size_t size = last - first;
	size_t rows = std::sqrt(size);
	size_t r, c;
	for (r = 0; r < rows - 1; r++)
		for (c = r + 1; c < rows; c++)
			std::swap(first[r * rows + c], first[c * rows + r]);
}

}

#endif
